## kim-api 2.4.1

=== CMakeLists.txt ===
#
# KIM-API: An API for interatomic models
# Copyright (c) 2013--2022, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Christoph Junghans
#    Ryan S. Elliott
#    Daniel S. Karls
#
# SPDX-License-Identifier: LGPL-2.1-or-later
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#

#
# Release: This file is part of the kim-api.git repository.
#


cmake_minimum_required(VERSION 3.10)
enable_testing()

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules)
list(APPEND CMAKE_PREFIX_PATH ${CMAKE_CURRENT_BINARY_DIR})

include(SetCacheWithFallback)
include(DefaultCompilerStandards)

# Define options
#
if(CMAKE_BUILD_TYPE STREQUAL "Debug")
  set(_LOG_MAX "DEBUG")
elseif(NOT DEFINED CMAKE_BUILD_TYPE OR CMAKE_BUILD_TYPE STREQUAL "")
  set(_LOG_MAX "INFORMATION")
  set(CMAKE_BUILD_TYPE "Release") # Default to Release, solves KIM slowdown complaints
else()
  set(_LOG_MAX "INFORMATION")
endif()

message(STATUS "KIM-API Build Type: ${CMAKE_BUILD_TYPE}")

set_cache_with_fallback(KIM_API_LOG_MAXIMUM_LEVEL "${_LOG_MAX}" STRING "Maximum log verbosity")
unset(_LOG_MAX)
set_property(CACHE KIM_API_LOG_MAXIMUM_LEVEL PROPERTY STRINGS "" SILENT FATAL ERROR WARNING INFORMATION DEBUG)
#
set(KIM_API_BASE64_BUFFERSIZE "16777216" CACHE STRING "base64 buffer size")
mark_as_advanced(KIM_API_BASE64_BUFFERSIZE)
#
option(KIM_API_BUILD_EXAMPLES "Build example Drivers, Models, Simulator Models, and Simulators" ON)
#
set(KIM_API_PROJECT_NAME "kim-api" CACHE STRING "KIM API project name string")
mark_as_advanced(KIM_API_PROJECT_NAME)
#
option(KIM_API_ENABLE_SANITIZE "Enable AddressSanitizer" OFF)
mark_as_advanced(KIM_API_ENABLE_SANITIZE)
#
option(KIM_API_ENABLE_COVERAGE "Enable code coverage" OFF)
mark_as_advanced(KIM_API_ENABLE_COVERAGE)
#
string(TIMESTAMP _KIM_API_CONFIGURATION_TIMESTAMP "%Y-%m-%d-%H-%M-%S" UTC)
set(KIM_API_CONFIGURATION_TIMESTAMP "${_KIM_API_CONFIGURATION_TIMESTAMP}" CACHE STRING "UTC timestamp for configuration of kim-api")
unset(_KIM_API_CONFIGURATION_TIMESTAMP)
mark_as_advanced(KIM_API_CONFIGURATION_TIMESTAMP)
#
# Additional options (that depend on call to project()) defined below


#
# Define main project
#
project(${KIM_API_PROJECT_NAME} VERSION 2.4.1 LANGUAGES CXX C Fortran)  # must remain a single line for create-pacakge script
set(PROJECT_DESCRIPTION "An Application Programming Interface (API) for the Knowledgebase of Interatomic Models (KIM).")
#
include(GNUInstallDirs)  # needs to come after languages are enabled
include(RelocatableGNUInstallDirs)  # provides CMAKE_INSTALL_RELOC_*DIRS variables
include(DefineVersionVariables)


# Define options dependent on languages being enabled and/or PROJECT_NAME being defined
#
set(KIM_API_CMAKE_C_COMPILER "${CMAKE_C_COMPILER}" CACHE FILEPATH "C compiler filepath to be used after installation for item compilation.")
mark_as_advanced(KIM_API_CMAKE_C_COMPILER)
set(KIM_API_CMAKE_CXX_COMPILER "${CMAKE_CXX_COMPILER}" CACHE FILEPATH "C++ compiler filepath to be used after installation for item compilation.")
mark_as_advanced(KIM_API_CMAKE_CXX_COMPILER)
set(KIM_API_CMAKE_Fortran_COMPILER "${CMAKE_Fortran_COMPILER}" CACHE FILEPATH "Fortran compiler filepath to be used after installation for item compilation.")
mark_as_advanced(KIM_API_CMAKE_Fortran_COMPILER)

include(DefineInternalVariables)
#
# Define options dependent on internal variables
#
include(CompletionConfig)  # set install dirs for completions;  NOTE: depends on Module 'DefineInternalVariables'
set_cache_with_fallback(KIM_API_USER_CONFIGURATION_FILE ".${PROJECT_NAME}/${KIM_API_UID}/config" FILEPATH "Default configuration file name. If not absolute, then relative to user home directory")
mark_as_advanced(KIM_API_USER_CONFIGURATION_FILE)
# "~/" is expanded by cmake when set(... CACHE PATH ...) is used below; so do not use PATH as type
set_cache_with_fallback(KIM_API_USER_MODEL_DRIVERS_DIR_DEFAULT "~/.${PROJECT_NAME}/${KIM_API_UID}/${KIM_API_MODEL_DRIVER_PLURAL_DIR_IDENTIFIER}" STRING "Default user collection model drivers dir")  # do not use PATH type
mark_as_advanced(KIM_API_USER_MODEL_DRIVERS_DIR_DEFAULT)
set_cache_with_fallback(KIM_API_USER_PORTABLE_MODELS_DIR_DEFAULT "~/.${PROJECT_NAME}/${KIM_API_UID}/${KIM_API_PORTABLE_MODEL_PLURAL_DIR_IDENTIFIER}" STRING "Default user collection portable models dir")  # do not use PATH type
mark_as_advanced(KIM_API_USER_PORTABLE_MODELS_DIR_DEFAULT)
set_cache_with_fallback(KIM_API_USER_SIMULATOR_MODELS_DIR_DEFAULT "~/.${PROJECT_NAME}/${KIM_API_UID}/${KIM_API_SIMULATOR_MODEL_PLURAL_DIR_IDENTIFIER}" STRING "Default user collection simulator models dir")  # do not use PATH type
mark_as_advanced(KIM_API_USER_SIMULATOR_MODELS_DIR_DEFAULT)
#
#
macro(_set_system_dir var identifier type_string)
  set(_default_dir_1 "${PROJECT_NAME}/${identifier}")  # _1 single escape -- to be used directly
  set(_default_dir_2 "${PROJECT_NAME}/${identifier}")  # _2 double escape -- to be passed into macro/function
  set(_description "System collection (${KIM_API_PATH_SEPARATOR}-separated) ${type_string} directory list (entries may begin with $ORIGIN (w/ or w/o {}'s), if appropriate)")
  if(WIN32 AND NOT CYGWIN)
    # Note: On Win32, ${ORIGIN} refers to the bin/ directory containing libkim-api.dll.
    file(RELATIVE_PATH _relative_libdir_path "${CMAKE_INSTALL_FULL_BINDIR}" "${CMAKE_INSTALL_FULL_LIBDIR}")
    set(_default_dir_1 "\${ORIGIN}/${_relative_libdir_path}/${_default_dir_1}")   # Here is the important difference between the _1 and _2
    set(_default_dir_2 "\\\${ORIGIN}/${_relative_libdir_path}/${_default_dir_2}") # Here is the important difference between the _1 and _2
    unset(_relative_libdir_path)
  else()
    set(_default_dir_1 "\${ORIGIN}/${_default_dir_1}")   # Here is the important difference between the _1 and _2
    set(_default_dir_2 "\\\${ORIGIN}/${_default_dir_2}") # Here is the important difference between the _1 and _2
  endif()
  set_cache_with_fallback(${var} "${_default_dir_2}" STRING ${_description})
  if("${${var}}" MATCHES "^${KIM_API_PATH_SEPARATOR}")
    set(${var} "${_default_dir_1}${${var}}")
  endif()
  unset(_default_dir_1)
  unset(_default_dir_2)
  unset(_description)
  mark_as_advanced(${var})
endmacro(_set_system_dir)
#
_set_system_dir(KIM_API_SYSTEM_MODEL_DRIVERS_DIR "${KIM_API_MODEL_DRIVER_PLURAL_IDENTIFIER}" "model drivers")
#
_set_system_dir(KIM_API_SYSTEM_PORTABLE_MODELS_DIR "${KIM_API_PORTABLE_MODEL_PLURAL_IDENTIFIER}" "portable models")
#
_set_system_dir(KIM_API_SYSTEM_SIMULATOR_MODELS_DIR "${KIM_API_SIMULATOR_MODEL_PLURAL_IDENTIFIER}" "simulator models")


include(DefaultCompilerFlags)

# Define kim-api target
#
add_library(kim-api SHARED "")
set_target_properties(kim-api
  PROPERTIES
    OUTPUT_NAME "${PROJECT_NAME}"
    VERSION ${PROJECT_VERSION}
    SOVERSION ${PROJECT_VERSION_MAJOR}
    Fortran_MODULE_DIRECTORY "${PROJECT_BINARY_DIR}/fortran/${KIM_API_Fortran_MODULE_DIR_IDENTIFIER}"
    )
target_include_directories(kim-api PUBLIC
  $<BUILD_INTERFACE:$<TARGET_PROPERTY:kim-api,Fortran_MODULE_DIRECTORY>>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_RELOC_LIBDIR}/${PROJECT_NAME}/${KIM_API_Fortran_MODULE_DIR_IDENTIFIER}>)
if(NOT WIN32 OR CYGWIN)
  target_link_libraries(kim-api PRIVATE ${CMAKE_DL_LIBS})
endif()

# Add install rules for kim-api
#
install(TARGETS kim-api
  EXPORT KIM_API_Targets
  # use CMAKE_INSTALL_RELOC_* to get relocatable GNUInstallDir behavior
  INCLUDES DESTINATION "${CMAKE_INSTALL_RELOC_INCLUDEDIR}/${PROJECT_NAME}"
  LIBRARY DESTINATION "${CMAKE_INSTALL_RELOC_LIBDIR}"
  ARCHIVE DESTINATION "${CMAKE_INSTALL_RELOC_LIBDIR}"
  RUNTIME DESTINATION "${CMAKE_INSTALL_RELOC_BINDIR}")

# Add install rules for various metadata files
#
install(
  FILES
    "${PROJECT_SOURCE_DIR}/README.md"
    "${PROJECT_SOURCE_DIR}/NEWS"
    "${PROJECT_SOURCE_DIR}/LICENSE.LGPL"
  DESTINATION
    "${CMAKE_INSTALL_RELOC_DOCDIR}"
  )

# Add include subdirectories
#
add_subdirectory(cpp/include)
add_subdirectory(c/include)
add_subdirectory(fortran/include)

# Add src subdirectories
#
add_subdirectory(cpp/src)
add_subdirectory(c/src)
add_subdirectory(fortran/src)

# Add cmake subdirectory
#
add_subdirectory(cmake)

#
string(MAKE_C_IDENTIFIER "${PROJECT_NAME}" KIM_API_C_ID_PROJECT_NAME)  # used in ./completions and ./utils
#

# Add utils subdirectory
#
add_subdirectory(utils)

# Add other subdirectories
#
add_subdirectory(docs)
add_subdirectory(completions)
add_subdirectory(editors/emacs)
add_subdirectory(pkg-config)

# Add Models & Drivers
#
if(KIM_API_BUILD_EXAMPLES)
  set(KIM_API_CMAKE_PREFIX_DIR "")  # avoid uninitialized variable warning
  set(KIM-API_DIR "${PROJECT_BINARY_DIR}/cmake/${KIM_API_BUILD_TREE_CONFIG_DIR_IDENTIFIER}")
  set(KIM-API-ITEMS_DIR "${PROJECT_BINARY_DIR}/cmake/${KIM_API_BUILD_TREE_CONFIG_DIR_IDENTIFIER}-items")
  add_subdirectory(examples/model-drivers)
  add_subdirectory(examples/portable-models)
  add_subdirectory(examples/simulator-models)
  add_subdirectory(examples/simulators)
  unset(KIM_API_CMAKE_PREFIX_DIR)
  unset(KIM-API_DIR)
  unset(KIM-API-ITEMS_DIR)
endif()

include(WriteKIMConfigSummary)

=== completions/CMakeLists.txt ===
#
# KIM-API: An API for interatomic models
# Copyright (c) 2013--2022, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Richard Berger
#    Christoph Junghans
#    Ryan S. Elliott
#    Jim Madge
#    Yaser Afshar
#
# SPDX-License-Identifier: LGPL-2.1-or-later
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#

#
# Release: This file is part of the kim-api.git repository.
#


include(RelocatablePath)

set(BASH_COMPLETIONS ${PROJECT_NAME}-collections-management.bash)
set(ZSH_COMPLETIONS ${PROJECT_NAME}-collections-management.zsh)

relocatable_path(
  FROM "${BASH_COMPLETION_FULL_COMPLETIONSDIR}" FROM_REL "${CMAKE_INSTALL_RELOC_SYSCONFDIR}"
  TO "${CMAKE_INSTALL_FULL_LIBEXECDIR}/${PROJECT_NAME}/${PROJECT_NAME}-collections-info" TO_REL "${CMAKE_INSTALL_RELOC_LIBEXECDIR}"
  PREFIX "\${ORIGIN}"
  RESULT_VARIABLE _collections_info_rel
  )
configure_file(collections-management.bash.in ${BASH_COMPLETIONS} @ONLY)
unset(_collections_info_rel)

relocatable_path(
  FROM "${ZSH_COMPLETION_FULL_COMPLETIONSDIR}" FROM_REL "${CMAKE_INSTALL_RELOC_SYSCONFDIR}"
  TO "${BASH_COMPLETION_FULL_COMPLETIONSDIR}/${BASH_COMPLETIONS}" TO_REL "${CMAKE_INSTALL_RELOC_SYSCONFDIR}"
  PREFIX "\${ORIGIN}"
  RESULT_VARIABLE _bashcomp_rel
  )
configure_file(collections-management.zsh.in ${ZSH_COMPLETIONS} @ONLY)
unset(_bashcomp_rel)


install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/${BASH_COMPLETIONS}
  # use CMAKE_INSTALL_RELOC_* to get relocatable GNUInstallDir behavior
  DESTINATION ${BASH_COMPLETION_RELOC_COMPLETIONSDIR}
  )

install(
  FILES
  ${CMAKE_CURRENT_BINARY_DIR}/${ZSH_COMPLETIONS}
  # use CMAKE_INSTALL_RELOC_* to get relocatable GNUInstallDir behavior
  DESTINATION ${ZSH_COMPLETION_RELOC_COMPLETIONSDIR}
  RENAME "_${PROJECT_NAME}-collections-management"
  )

=== docs/CMakeLists.txt ===
#
# KIM-API: An API for interatomic models
# Copyright (c) 2013--2022, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Richard Berger
#    Christoph Junghans
#    Ryan S. Elliott
#
# SPDX-License-Identifier: LGPL-2.1-or-later
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#

#
# Release: This file is part of the kim-api.git repository.
#

cmake_minimum_required(VERSION 3.10)

find_package(Doxygen QUIET)
if(Doxygen_FOUND)
  include(FindPackageMessage)
  find_package_message(Doxygen "Found Doxygen: (${DOXYGEN_EXECUTABLE})" "found")
endif()

set(DOXYGEN_PROJECT_NAME         "${PROJECT_NAME}")
set(DOXYGEN_PROJECT_NUMBER       "${PROJECT_VERSION_STRING}")
set(DOXYGEN_STRIP_FROM_PATH      "../../")
set(DOXYGEN_CASE_SENSE_NAMES     NO)
set(DOXYGEN_TAB_SIZE             2)
set(DOXYGEN_EXCLUDE_SYMBOLS      "*_DEFINED_" "*_HPP_" "*_H_")
set(DOXYGEN_ENABLE_PREPROCESSING YES)
set(DOXYGEN_SKIP_FUNCTION_MACROS NO)
set(DOXYGEN_EXTRACT_ALL          YES)
set(DOXYGEN_EXTRACT_STATIC       YES)
set(DOXYGEN_EXTRACT_ANON_NSPACES YES)
set(DOXYGEN_FILE_PATTERNS
  "*.c" "*.cpp" "*.h" "*.h.in" "*.hpp" "*.hpp.in" "*.inc" "*.f90"
  )
# additional patterns for examples
set(DOXYGEN_FILE_PATTERNS ${DOXYGEN_FILE_PATTERNS}
  "*.LGPL" "*.txt" "*.sh" "README" "*.params" "*.in" "*.bib" "*.edn"
  )
set(DOXYGEN_EXTENSION_MAPPING    "in=C++")

set(DOXYGEN_RECURSIVE            YES)
set(DOXYGEN_EXAMPLE_PATH         "../examples")
set(DOXYGEN_IMAGE_PATH           "src/asymptote-figures")
set(DOXYGEN_SOURCE_BROWSER       YES)
set(DOXYGEN_USE_MATHJAX          YES)
set(DOXYGEN_MATHJAX_RELPATH      "https://cdn.jsdelivr.net/npm/mathjax@2")
set(DOXYGEN_EXTRA_PACKAGES       "amsmath")
set(DOXYGEN_GENERATE_LATEX       YES)

if(READTHEDOCS)
  set(DOXYGEN_HTML_FOOTER "readthedocs/footer.html")
endif(READTHEDOCS)

set(SOURCES
  "src/cmake-files.txt"
  "src/table-of-contents.txt"
  "src/features.txt"
  "src/theory.txt"
  "src/implementation.txt"
  "src/version2-differences.txt"
  "../cpp/include/"
  "../c/include/"
  "../fortran/include/"
  "../INSTALL"
  "../NEWS"
  "../examples/model-drivers/"
  "../examples/portable-models/"
  "../examples/simulator-models/"
  "../examples/simulators/"
  )

if(DOXYGEN_FOUND)
  doxygen_add_docs(
    docs
    ${SOURCES}
    COMMENT "Generate documentation"
    )

  add_custom_command(OUTPUT refman.pdf
    COMMAND make
    COMMAND ${CMAKE_COMMAND} -E copy refman.pdf ${CMAKE_CURRENT_BINARY_DIR}/refman.pdf
    WORKING_DIRECTORY latex
    DEPENDS docs
    )

  # TODO fix dependencies
  add_custom_target(pdf DEPENDS docs refman.pdf SOURCES ${SOURCES})
endif(DOXYGEN_FOUND)

install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
  # use CMAKE_INSTALL_RELOC_* to get relocatable GNUInstallDir behavior
  DESTINATION ${CMAKE_INSTALL_RELOC_DOCDIR} OPTIONAL)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/refman.pdf
  # use CMAKE_INSTALL_RELOC_* to get relocatable GNUInstallDir behavior
  DESTINATION ${CMAKE_INSTALL_RELOC_DOCDIR} OPTIONAL)

=== pkg-config/CMakeLists.txt ===
#
# KIM-API: An API for interatomic models
# Copyright (c) 2013--2022, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Richard Berger
#    Christoph Junghans
#    Ryan S. Elliott
#    Alexander Stukowski
#
# SPDX-License-Identifier: LGPL-2.1-or-later
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#

#
# Release: This file is part of the kim-api.git repository.
#


# use 'lib' instead of '${CMAKE_SHARED_LIBRARY_PREFIX}' here to have consistency
# of pkg-config usage across systems.
set(PKG_CONFIG_FILE "lib${PROJECT_NAME}.pc")

relocatable_path(
  FROM "${CMAKE_INSTALL_FULL_LIBDIR}/${KIM_API_PKG_CONFIG_DIR_IDENTIFIER}" FROM_REL "${CMAKE_INSTALL_RELOC_LIBDIR}"
  TO "${CMAKE_INSTALL_PREFIX}" TO_REL "./"
  PREFIX "\${pcfiledir}"
  RESULT_VARIABLE _installdir_rel
  )
relocatable_path(
  FROM "${CMAKE_INSTALL_PREFIX}" FROM_REL "./"
  TO "${CMAKE_INSTALL_FULL_BINDIR}" TO_REL "${CMAKE_INSTALL_RELOC_BINDIR}"
  PREFIX "\${prefix}"
  RESULT_VARIABLE _bindir_rel
  )
relocatable_path(
  FROM "${CMAKE_INSTALL_PREFIX}" FROM_REL "./"
  TO "${CMAKE_INSTALL_FULL_LIBEXECDIR}" TO_REL "${CMAKE_INSTALL_RELOC_LIBEXECDIR}"
  PREFIX "\${prefix}"
  RESULT_VARIABLE _libexecdir_rel
  )
relocatable_path(
  FROM "${CMAKE_INSTALL_PREFIX}" FROM_REL "./"
  TO "${CMAKE_INSTALL_FULL_SYSCONFDIR}" TO_REL "${CMAKE_INSTALL_RELOC_SYSCONFDIR}"
  PREFIX "\${prefix}"
  RESULT_VARIABLE _sysconfdir_rel
  )
relocatable_path(
  FROM "${CMAKE_INSTALL_PREFIX}" FROM_REL "./"
  TO "${CMAKE_INSTALL_FULL_LIBDIR}" TO_REL "${CMAKE_INSTALL_RELOC_LIBDIR}"
  PREFIX "\${prefix}"
  RESULT_VARIABLE _libdir_rel
  )
relocatable_path(
  FROM "${CMAKE_INSTALL_PREFIX}" FROM_REL "./"
  TO "${CMAKE_INSTALL_FULL_INCLUDEDIR}" TO_REL "${CMAKE_INSTALL_RELOC_INCLUDEDIR}"
  PREFIX "\${prefix}"
  RESULT_VARIABLE _includedir_rel
  )
relocatable_path(
  FROM "${CMAKE_INSTALL_PREFIX}" FROM_REL "./"
  TO "${CMAKE_INSTALL_FULL_LIBDIR}/${PROJECT_NAME}/${KIM_API_Fortran_MODULE_DIR_IDENTIFIER}" TO_REL "${CMAKE_INSTALL_RELOC_LIBDIR}"
  PREFIX "\${prefix}"
  RESULT_VARIABLE _moddir_rel
  )
relocatable_path(
  FROM "${CMAKE_INSTALL_PREFIX}" FROM_REL "./"
  TO "${CMAKE_INSTALL_FULL_DOCDIR}" TO_REL "${CMAKE_INSTALL_RELOC_DOCDIR}"
  PREFIX "\${prefix}"
  RESULT_VARIABLE _docdir_rel
  )
list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_FULL_LIBDIR}" _isSystemDir)
if("${_isSystemDir}" STREQUAL "-1")
  set(KIM_API_RPATH_FLAG [=[-Wl,-rpath,${libdir}]=])
else()
  set(KIM_API_RPATH_FLAG "")
endif()
unset(_isSystemDir)
configure_file(libkim-api.pc.in ${PKG_CONFIG_FILE} @ONLY)
unset(_installdir_rel)
unset(_bindir_rel)
unset(_libexecdir_rel)
unset(_sysconfdir_rel)
unset(_libdir_rel)
unset(_includedir_rel)
unset(_moddir_rel)
unset(_docdir_rel)


install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/${PKG_CONFIG_FILE}
  # use CMAKE_INSTALL_RELOC_* to get relocatable GNUInstallDir behavior
  DESTINATION ${CMAKE_INSTALL_RELOC_LIBDIR}/${KIM_API_PKG_CONFIG_DIR_IDENTIFIER}
  )

=== utils/CMakeLists.txt ===
#
# KIM-API: An API for interatomic models
# Copyright (c) 2013--2022, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Christoph Junghans
#    Ryan S. Elliott
#    Daniel S. Karls
#
# SPDX-License-Identifier: LGPL-2.1-or-later
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#

#
# Release: This file is part of the kim-api.git repository.
#


include(RelocatablePath)

set(PORTABLE_MODEL_INFO    ${PROJECT_NAME}-portable-model-info)
set(SIMULATOR_MODEL        ${PROJECT_NAME}-simulator-model)
set(COLLECTIONS_INFO       ${PROJECT_NAME}-collections-info)
set(BASE64_ENCODE          ${PROJECT_NAME}-base64-encode)
set(COLLECTIONS_MANAGEMENT ${PROJECT_NAME}-collections-management)
set(SHARED_LIBRARY_TEST    ${PROJECT_NAME}-shared-library-test)
set(ACTIVATE_SCRIPT        ${PROJECT_NAME}-activate)
set(DEACTIVATE_SCRIPT      ${PROJECT_NAME}-deactivate)

# Set RPATH to support relocatable behavior for utilities
if((NOT ("${CMAKE_INSTALL_PREFIX}" IN_LIST KIM_API_STANDARD_INSTALL_PREFIXES))
    AND (NOT "${CMAKE_SYSTEM_NAME}" STREQUAL "Windows"))
  if("${CMAKE_SYSTEM_NAME}" STREQUAL "Darwin")
    set(_rpath_prefix "@loader_path")
  else()
    set(_rpath_prefix "$ORIGIN")
  endif()
  relocatable_path(
    FROM "${CMAKE_INSTALL_FULL_LIBEXECDIR}/${PROJECT_NAME}" FROM_REL "${CMAKE_INSTALL_RELOC_LIBEXECDIR}"
    TO "${CMAKE_INSTALL_FULL_LIBDIR}" TO_REL "${CMAKE_INSTALL_RELOC_LIBDIR}"
    PREFIX "${_rpath_prefix}"
    RESULT_VARIABLE _rel_rpath
    )
  unset(_rpath_prefix)
  if(NOT IS_ABSOLUTE "${_rel_rpath}")
    list(APPEND CMAKE_INSTALL_RPATH "${_rel_rpath}")
  endif()
  unset(_rel_rpath)
endif()


if(NOT WIN32 OR CYGWIN)
  relocatable_path(
    FROM "${CMAKE_INSTALL_FULL_BINDIR}" FROM_REL "${CMAKE_INSTALL_RELOC_BINDIR}"
    TO "${CMAKE_INSTALL_FULL_LIBEXECDIR}/${PROJECT_NAME}/${COLLECTIONS_INFO}" TO_REL "${CMAKE_INSTALL_RELOC_LIBEXECDIR}"
    PREFIX "\${ORIGIN}"
    RESULT_VARIABLE _collections_info_path
    )
else()
  # Note: On WIN32, 'collections-info.exe' and other utilities get installed under ${CMAKE_INSTALL_PREFIX}/bin/.
  relocatable_path(
    FROM "${CMAKE_INSTALL_FULL_BINDIR}" FROM_REL "${CMAKE_INSTALL_RELOC_BINDIR}"
    TO "${CMAKE_INSTALL_FULL_BINDIR}/${COLLECTIONS_INFO}" TO_REL "${CMAKE_INSTALL_RELOC_BINDIR}"
    PREFIX "\${ORIGIN}"
    RESULT_VARIABLE _collections_info_path
    )
endif()
configure_file(collections-management.in ${COLLECTIONS_MANAGEMENT} @ONLY)
unset(_collections_info_path)

relocatable_path(
  FROM "${CMAKE_INSTALL_FULL_BINDIR}" FROM_REL "${CMAKE_INSTALL_RELOC_BINDIR}"
  TO "${CMAKE_INSTALL_PREFIX}" TO_REL "./"
  PREFIX "\${ORIGIN}"
  RESULT_VARIABLE _installdir_rel
  )
relocatable_path(
  FROM "${CMAKE_INSTALL_FULL_BINDIR}" FROM_REL "${CMAKE_INSTALL_RELOC_BINDIR}"
  TO "${CMAKE_INSTALL_FULL_LIBDIR}" TO_REL "${CMAKE_INSTALL_RELOC_LIBDIR}"
  PREFIX "\${ORIGIN}"
  RESULT_VARIABLE _libdir_rel
  )
relocatable_path(
  FROM "${CMAKE_INSTALL_FULL_BINDIR}" FROM_REL "${CMAKE_INSTALL_RELOC_BINDIR}"
  TO "${BASH_COMPLETION_FULL_COMPLETIONSDIR}" TO_REL "${BASH_COMPLETION_RELOC_COMPLETIONSDIR}"
  PREFIX "\${ORIGIN}"
  RESULT_VARIABLE _bashcompdir_rel
  )
relocatable_path(
  FROM "${CMAKE_INSTALL_FULL_BINDIR}" FROM_REL "${CMAKE_INSTALL_RELOC_BINDIR}"
  TO "${ZSH_COMPLETION_FULL_COMPLETIONSDIR}" TO_REL "${ZSH_COMPLETION_RELOC_COMPLETIONSDIR}"
  PREFIX "\${ORIGIN}"
  RESULT_VARIABLE _zshcompdir_rel
  )
configure_file(activate.in ${ACTIVATE_SCRIPT} @ONLY)
configure_file(deactivate.in ${DEACTIVATE_SCRIPT} @ONLY)
unset(_installdir_rel)
unset(_libdir_rel)
unset(_bashcompdir_rel)
unset(_zshcompdir_rel)

add_executable(portable-model-info portable-model-info.cpp)
target_link_libraries(portable-model-info kim-api)
target_include_directories(portable-model-info PRIVATE "${PROJECT_SOURCE_DIR}/cpp/src")
set_target_properties(portable-model-info PROPERTIES OUTPUT_NAME ${PORTABLE_MODEL_INFO})

add_executable(simulator-model simulator-model.cpp)
target_link_libraries(simulator-model kim-api)
set_target_properties(simulator-model PROPERTIES OUTPUT_NAME ${SIMULATOR_MODEL})

add_executable(collections-info collections-info.cpp)
target_include_directories(collections-info PRIVATE "${PROJECT_SOURCE_DIR}/cpp/src")
target_link_libraries(collections-info kim-api)
set_target_properties(collections-info PROPERTIES OUTPUT_NAME ${COLLECTIONS_INFO})

add_executable(base64-encode base64-encode.cpp ${PROJECT_SOURCE_DIR}/cpp/src/libb64/libb64/src/cencode.c)
target_include_directories(base64-encode PRIVATE "${PROJECT_BINARY_DIR}/cpp/include")
target_include_directories(base64-encode PRIVATE "${PROJECT_SOURCE_DIR}/cpp/src/libb64/libb64/include")
set_target_properties(base64-encode PROPERTIES OUTPUT_NAME ${BASE64_ENCODE})
target_compile_definitions(base64-encode PRIVATE BUFFERSIZE=${KIM_API_BASE64_BUFFERSIZE})

add_executable(shared-library-test shared-library-test.cpp)
target_include_directories(shared-library-test PRIVATE "${PROJECT_BINARY_DIR}/cpp/include")
target_link_libraries(shared-library-test ${CMAKE_DL_LIBS})
set_target_properties(shared-library-test PROPERTIES OUTPUT_NAME ${SHARED_LIBRARY_TEST})

# use CMAKE_INSTALL_RELOC_* to get relocatable GNUInstallDir behavior
if(NOT WIN32 OR CYGWIN)
  set(_dir "${CMAKE_INSTALL_RELOC_LIBEXECDIR}/${PROJECT_NAME}")
else()
  set(_dir "${CMAKE_INSTALL_RELOC_BINDIR}")
endif()
install(
  TARGETS portable-model-info simulator-model collections-info base64-encode shared-library-test
  EXPORT KIM_API_Targets
  DESTINATION "${_dir}"
  )
unset(_dir)

install(
  PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/${COLLECTIONS_MANAGEMENT}
  # use CMAKE_INSTALL_RELOC_* to get relocatable GNUInstallDir behavior
  DESTINATION ${CMAKE_INSTALL_RELOC_BINDIR}
  )

if(NOT ("${CMAKE_INSTALL_PREFIX}" IN_LIST KIM_API_STANDARD_INSTALL_PREFIXES))
  install(
    PROGRAMS
    ${CMAKE_CURRENT_BINARY_DIR}/${ACTIVATE_SCRIPT}
    ${CMAKE_CURRENT_BINARY_DIR}/${DEACTIVATE_SCRIPT}
    DESTINATION
    # use CMAKE_INSTALL_RELOC_* to get relocatable GNUInstallDir behavior
    ${CMAKE_INSTALL_RELOC_BINDIR}
    )
endif()

=== c/include/CMakeLists.txt ===
#
# KIM-API: An API for interatomic models
# Copyright (c) 2013--2022, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Richard Berger
#    Christoph Junghans
#    Ryan S. Elliott
#
# SPDX-License-Identifier: LGPL-2.1-or-later
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#

#
# Release: This file is part of the kim-api.git repository.
#


target_include_directories(kim-api PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
  $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
  )

configure_file(KIM_Version.h.in ${CMAKE_CURRENT_BINARY_DIR}/KIM_Version.h)

set(C_HEADERS
    KIM_ChargeUnit.h
    KIM_Collection.h
    KIM_Collections.h
    KIM_CollectionItemType.h
    KIM_ComputeArgumentName.h
    KIM_ComputeArguments.h
    KIM_ComputeCallbackName.h
    KIM_DataType.h
    KIM_EnergyUnit.h
    KIM_FunctionTypes.h
    KIM_LanguageName.h
    KIM_LengthUnit.h
    KIM_Log.h
    KIM_LogMacros.h
    KIM_LogVerbosity.h
    KIM_Model.h
    KIM_ModelCompute.h
    KIM_ModelComputeArgumentsCreate.h
    KIM_ModelComputeArgumentsDestroy.h
    KIM_ModelComputeArguments.h
    KIM_ModelCreate.h
    KIM_ModelExtension.h
    KIM_ModelDestroy.h
    KIM_ModelDriverCreate.h
    KIM_ModelDriverHeaders.h
    KIM_ModelHeaders.h
    KIM_ModelRefresh.h
    KIM_ModelRoutineName.h
    KIM_ModelWriteParameterizedModel.h
    KIM_Numbering.h
    KIM_SemVer.h
    KIM_SimulatorHeaders.h
    KIM_SimulatorModel.h
    KIM_SpeciesName.h
    KIM_SupportStatus.h
    KIM_SupportedExtensions.h
    KIM_TemperatureUnit.h
    KIM_TimeUnit.h
    KIM_UnitSystem.h
    ${CMAKE_CURRENT_BINARY_DIR}/KIM_Version.h
    )

install(FILES ${C_HEADERS}
  # use CMAKE_INSTALL_RELOC_* to get relocatable GNUInstallDir behavior
  DESTINATION ${CMAKE_INSTALL_RELOC_INCLUDEDIR}/${PROJECT_NAME})

=== cmake/Modules/CMakeLists.txt ===
#
# KIM-API: An API for interatomic models
# Copyright (c) 2013--2022, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Richard Berger
#    Christoph Junghans
#    Ryan S. Elliott
#
# SPDX-License-Identifier: LGPL-2.1-or-later
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#

#
# Release: This file is part of the kim-api.git repository.
#


# nothing to be done here...

=== cpp/src/CMakeLists.txt ===
#
# KIM-API: An API for interatomic models
# Copyright (c) 2013--2022, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Richard Berger
#    Christoph Junghans
#    Ryan S. Elliott
#    Alexander Stukowski
#
# SPDX-License-Identifier: LGPL-2.1-or-later
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#

#
# Release: This file is part of the kim-api.git repository.
#


target_include_directories(kim-api PRIVATE
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ${PROJECT_SOURCE_DIR}/cmake  # for KIM_SharedLibrarySchema.hpp
  ${CMAKE_CURRENT_SOURCE_DIR}/libb64/libb64/include
  )

configure_file(KIM_Configuration.hpp.in ${CMAKE_CURRENT_BINARY_DIR}/KIM_Configuration.hpp)

set(CPP_SOURCES
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ChargeUnit.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_Collection.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_CollectionItemType.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_Collections.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_CollectionsImplementation.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ComputeArgumentName.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ComputeArguments.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ComputeCallbackName.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_DataType.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_EnergyUnit.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_FilesystemPath.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_LanguageName.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_LengthUnit.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_Log.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_LogVerbosity.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_Model.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ModelCompute.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ModelComputeArguments.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ModelComputeArgumentsCreate.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ModelComputeArgumentsDestroy.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ModelCreate.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ModelDestroy.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ModelDriverCreate.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ModelExtension.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ModelRefresh.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ModelRoutineName.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ModelWriteParameterizedModel.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_Numbering.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_SemVer.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_SpeciesName.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_SupportStatus.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_SimulatorModel.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_SimulatorModelImplementation.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_TemperatureUnit.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_TimeUnit.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ComputeArgumentsImplementation.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_LogImplementation.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ModelImplementation.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_SharedLibrary.cpp
)

set(C_SOURCES
  ${CMAKE_CURRENT_SOURCE_DIR}/libb64/libb64/src/cdecode.c
  ${CMAKE_CURRENT_SOURCE_DIR}/libb64/libb64/src/cencode.c
)
target_compile_definitions(kim-api PRIVATE BUFFERSIZE=${KIM_API_BASE64_BUFFERSIZE})

target_sources(kim-api PRIVATE ${CPP_SOURCES} ${C_SOURCES})

if(WIN32 AND NOT CYGWIN)
  # Activate C++17 language standard on Win32 platform, because kim-api code uses C++ filesystem library internally.
  # Note: The 'cxx_std_17' target compile feature was added by CMake version 3.8.
  # For older CMake versions, fall back to setting the CXX_STANDARD target property instead.
  get_property(cxx_features GLOBAL PROPERTY CMAKE_CXX_KNOWN_FEATURES)
  if("cxx_std_17" IN_LIST cxx_features)
    target_compile_features(kim-api PUBLIC cxx_std_17)
  else()
    set_property(TARGET kim-api PROPERTY CXX_STANDARD 17)
    set_property(TARGET kim-api PROPERTY CXX_STANDARD_REQUIRED YES)
  endif()
endif()

# The KIM API code uses POSIX.1-2008 functions such as strdup() or mkstemp(), which are
# not part of the ISO C standard. Thus, when compiling with -std=c++98 instead of -std=gnu98,
# these function would be unavailable.
# Defining _DEFAULT_SOURCE during compilation tells the GNU C Library headers to make the
# POSIX and System V functions available also in strict ANSI C mode.
# See also: https://www.gnu.org/software/libc/manual/html_node/Feature-Test-Macros.html
target_compile_definitions(kim-api PRIVATE _DEFAULT_SOURCE)

=== examples/portable-models/CMakeLists.txt ===
#
# KIM-API: An API for interatomic models
# Copyright (c) 2013--2022, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Richard Berger
#    Christoph Junghans
#    Ryan S. Elliott
#
# SPDX-License-Identifier: LGPL-2.1-or-later
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#

#
# Release: This file is part of the kim-api.git repository.
#


cmake_minimum_required(VERSION 3.10)

add_subdirectory(ex_model_Ar_P_LJ)
add_subdirectory(ex_model_Ar_P_MLJ_Fortran)
add_subdirectory(ex_model_Ar_P_Morse)
add_subdirectory(ex_model_Ar_P_Morse_07C)
add_subdirectory(ex_model_Ar_P_Morse_07C_w_Extensions)
add_subdirectory(ex_model_Ar_P_Morse_MultiCutoff)
add_subdirectory(ex_model_Ar_SLJ_MultiCutoff)
add_subdirectory(LennardJones612_UniversalShifted__MO_959249795837_003)
add_subdirectory(LennardJones_Ar)

=== examples/simulators/CMakeLists.txt ===
#
# KIM-API: An API for interatomic models
# Copyright (c) 2013--2022, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Richard Berger
#    Christoph Junghans
#    Ryan S. Elliott
#
# SPDX-License-Identifier: LGPL-2.1-or-later
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#

#
# Release: This file is part of the kim-api.git repository.
#


cmake_minimum_required(VERSION 3.10)

set(_test_models
  LennardJones612_UniversalShifted__MO_959249795837_003
  LennardJones_Ar
  ex_model_Ar_P_LJ
  ex_model_Ar_P_MLJ_Fortran
  ex_model_Ar_P_Morse
  ex_model_Ar_P_Morse_07C
  ex_model_Ar_P_Morse_07C_w_Extensions
  ex_model_Ar_P_Morse_MultiCutoff
  ex_model_Ar_SLJ_MultiCutoff
  )

set(_testing_dir "${PROJECT_BINARY_DIR}/Testing")

function(_add_simulator_model_tests _simulator_name _test_models _test_models_fail_list)
  foreach(_model IN LISTS _test_models)
    set(_test_name "Run_${_simulator_name}_${_model}")
    set(_test_dir "${_testing_dir}/${_test_name}")
    file(MAKE_DIRECTORY "${_test_dir}")
    add_kim_api_test(NAME "${_test_name}"
      COMMAND sh -c "echo ${_model} | $<TARGET_FILE:${_simulator_name}> > stdout"
      WORKING_DIRECTORY "${_test_dir}"
      )
    set_property(TEST ${_test_name}
      APPEND PROPERTY ENVIRONMENT
        "${KIM_API_ENVIRONMENT_MODEL_DRIVER_PLURAL_DIR}=${PROJECT_BINARY_DIR}/examples/model-drivers"
        "${KIM_API_ENVIRONMENT_PORTABLE_MODEL_PLURAL_DIR}=${PROJECT_BINARY_DIR}/examples/portable-models"
        "${KIM_API_ENVIRONMENT_SIMULATOR_MODEL_PLURAL_DIR}=${PROJECT_BINARY_DIR}/examples/simulator-models"
      )
    if("${_model}" IN_LIST _test_models_fail_list)
      set_tests_properties("${_test_name}" PROPERTIES WILL_FAIL TRUE)
    endif()
  endforeach()
endfunction(_add_simulator_model_tests)

function(_add_simulator_tests _simulator_dir _simulator_name)
  set(_test_name "Run_${_simulator_name}")
  set(_test_dir "${_testing_dir}/${_test_name}")
  file(MAKE_DIRECTORY "${_test_dir}")
  add_kim_api_test(NAME "${_test_name}"
    COMMAND sh -c "$<TARGET_FILE:${_simulator_name}> > stdout"
    WORKING_DIRECTORY "${_test_dir}"
    )
  set_property(TEST ${_test_name}
    APPEND PROPERTY ENVIRONMENT
    "${KIM_API_ENVIRONMENT_MODEL_DRIVER_PLURAL_DIR}=${PROJECT_BINARY_DIR}/examples/model-drivers"
    "${KIM_API_ENVIRONMENT_PORTABLE_MODEL_PLURAL_DIR}=${PROJECT_BINARY_DIR}/examples/portable-models"
    "${KIM_API_ENVIRONMENT_SIMULATOR_MODEL_PLURAL_DIR}=${PROJECT_BINARY_DIR}/examples/simulator-models"
    )
endfunction(_add_simulator_tests)

add_subdirectory(collections-example)
_add_simulator_tests(collections-example collections-example)
_add_simulator_tests(collections-example collections-example-c)
_add_simulator_tests(collections-example collections-example-fortran)

add_subdirectory(ex_test_Ar_fcc_cluster)
_add_simulator_model_tests(ex_test_Ar_fcc_cluster "${_test_models}" "ex_model_Ar_P_Morse_MultiCutoff;ex_model_Ar_SLJ_MultiCutoff")

add_subdirectory(ex_test_Ar_fcc_cluster_cpp)
_add_simulator_model_tests(ex_test_Ar_fcc_cluster_cpp "${_test_models}" "ex_model_Ar_P_Morse_MultiCutoff;ex_model_Ar_SLJ_MultiCutoff")

add_subdirectory(ex_test_Ar_fcc_cluster_fortran)
_add_simulator_model_tests(ex_test_Ar_fcc_cluster_fortran "${_test_models}" "ex_model_Ar_P_Morse_MultiCutoff;ex_model_Ar_SLJ_MultiCutoff")

add_subdirectory(simulator-model-example simulator-model-example)
_add_simulator_tests(simulator-model-example simulator-model-example)
_add_simulator_tests(simulator-model-example simulator-model-example-c)
_add_simulator_tests(simulator-model-example simulator-model-example-fortran)

add_subdirectory(utility_forces_numer_deriv)

=== fortran/include/CMakeLists.txt ===
#
# KIM-API: An API for interatomic models
# Copyright (c) 2013--2022, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Richard Berger
#    Christoph Junghans
#    Ryan S. Elliott
#
# SPDX-License-Identifier: LGPL-2.1-or-later
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#

#
# Release: This file is part of the kim-api.git repository.
#


target_include_directories(kim-api PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>)

set(F_MOD_DIR $<TARGET_PROPERTY:kim-api,Fortran_MODULE_DIRECTORY>)
set(FORTRAN_MODULES
  ${F_MOD_DIR}/kim_charge_unit_module.mod
  ${F_MOD_DIR}/kim_collection_item_type_module.mod
  ${F_MOD_DIR}/kim_collection_module.mod
  ${F_MOD_DIR}/kim_collections_module.mod
  ${F_MOD_DIR}/kim_compute_argument_name_module.mod
  ${F_MOD_DIR}/kim_compute_arguments_module.mod
  ${F_MOD_DIR}/kim_compute_callback_name_module.mod
  ${F_MOD_DIR}/kim_data_type_module.mod
  ${F_MOD_DIR}/kim_energy_unit_module.mod
  ${F_MOD_DIR}/kim_language_name_module.mod
  ${F_MOD_DIR}/kim_length_unit_module.mod
  ${F_MOD_DIR}/kim_log_module.mod
  ${F_MOD_DIR}/kim_log_verbosity_module.mod
  ${F_MOD_DIR}/kim_model_compute_arguments_create_module.mod
  ${F_MOD_DIR}/kim_model_compute_arguments_destroy_module.mod
  ${F_MOD_DIR}/kim_model_compute_arguments_module.mod
  ${F_MOD_DIR}/kim_model_compute_module.mod
  ${F_MOD_DIR}/kim_model_create_module.mod
  ${F_MOD_DIR}/kim_model_extension_module.mod
  ${F_MOD_DIR}/kim_model_destroy_module.mod
  ${F_MOD_DIR}/kim_model_driver_create_module.mod
  ${F_MOD_DIR}/kim_model_driver_headers_module.mod
  ${F_MOD_DIR}/kim_model_headers_module.mod
  ${F_MOD_DIR}/kim_model_module.mod
  ${F_MOD_DIR}/kim_model_refresh_module.mod
  ${F_MOD_DIR}/kim_model_routine_name_module.mod
  ${F_MOD_DIR}/kim_model_write_parameterized_model_module.mod
  ${F_MOD_DIR}/kim_numbering_module.mod
  ${F_MOD_DIR}/kim_sem_ver_module.mod
  ${F_MOD_DIR}/kim_simulator_headers_module.mod
  ${F_MOD_DIR}/kim_simulator_model_module.mod
  ${F_MOD_DIR}/kim_species_name_module.mod
  ${F_MOD_DIR}/kim_support_status_module.mod
  ${F_MOD_DIR}/kim_supported_extensions_module.mod
  ${F_MOD_DIR}/kim_temperature_unit_module.mod
  ${F_MOD_DIR}/kim_time_unit_module.mod
  ${F_MOD_DIR}/kim_unit_system_module.mod
  )

install(FILES ${FORTRAN_MODULES}
  # use CMAKE_INSTALL_RELOC_* to get relocatable GNUInstallDir behavior
  DESTINATION ${CMAKE_INSTALL_RELOC_LIBDIR}/${PROJECT_NAME}/${KIM_API_Fortran_MODULE_DIR_IDENTIFIER})

set(F_SOURCES
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_charge_unit_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_collection_item_type_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_collection_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_collections_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_compute_argument_name_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_compute_arguments_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_compute_callback_name_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_data_type_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_energy_unit_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_language_name_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_length_unit_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_log_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_log_verbosity_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_model_compute_arguments_create_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_model_compute_arguments_destroy_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_model_compute_arguments_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_model_compute_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_model_create_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_model_extension_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_model_destroy_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_model_driver_create_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_model_driver_headers_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_model_headers_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_model_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_model_refresh_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_model_routine_name_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_model_write_parameterized_model_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_numbering_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_sem_ver_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_simulator_headers_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_simulator_model_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_species_name_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_support_status_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_supported_extensions_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_temperature_unit_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_time_unit_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_unit_system_module.f90
  )

target_sources(kim-api PRIVATE ${F_SOURCES})

=== fortran/src/CMakeLists.txt ===
#
# KIM-API: An API for interatomic models
# Copyright (c) 2013--2022, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Richard Berger
#    Christoph Junghans
#    Ryan S. Elliott
#
# SPDX-License-Identifier: LGPL-2.1-or-later
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#

#
# Release: This file is part of the kim-api.git repository.
#


set(F_SOURCES
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_convert_string_module.f90
  ${CMAKE_CURRENT_SOURCE_DIR}/kim_interoperable_types_module.f90
  )

target_sources(kim-api PRIVATE ${F_SOURCES})

=== debian/changelog ===
kim-api (2.4.1-3) unstable; urgency=medium

  * [fb15642] fix(tests): Update test input for cluster tests

  [ Debian Janitor ]
  * [f7d9996] Apply multi-arch hints. + libkim-api-doc: Add Multi-Arch: foreign.

 -- Anton Gladky <gladk@debian.org>  Fri, 22 Aug 2025 07:16:44 +0200

kim-api (2.4.1-2) unstable; urgency=medium

  * [975e973] fix: Relax openkim-models dependency version

 -- Anton Gladky <gladk@debian.org>  Tue, 19 Aug 2025 19:37:00 +0200

kim-api (2.4.1-1) unstable; urgency=medium

  * Upload into unstable.

 -- Anton Gladky <gladk@debian.org>  Sun, 17 Aug 2025 08:47:09 +0200

kim-api (2.4.1-1~exp1) experimental; urgency=medium

  * [f2cec81] refactor(copyright): Switch to LGPL-2.1-or-later
  * [23e29cb] New upstream version 2.4.1
  * [dc763ee] chore: Update Standards-Version to 4.7.2
  * [cca6d99] Update patch

 -- Anton Gladky <gladk@debian.org>  Sun, 15 Jun 2025 22:47:59 +0200

=== debian/control ===
Source: kim-api
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladk@debian.org>
Section: libs
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-fortran-mod,
               gfortran,
               xxd
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/science-team/kim-api
Vcs-Git: https://salsa.debian.org/science-team/kim-api.git
Homepage: https://openkim.org

Package: libkim-api-dev
Architecture: any
Section: libdevel
Depends: libkim-api2 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Development files for KIM-API
 The KIM API is an Application Programming Interface for atomistic simulations.
 The API provides a standard for exchanging information between atomistic
 simulation codes (molecular dynamics, molecular statics, lattice dynamics,
 Monte Carlo, etc.) and interatomic models (potentials or force fields).
 It also includes a set of library routines for using the API with
 bindings for:
 .
 FORTRAN 77, Fortran 90/95, Fortran 2003
 C, C++
 .
 Atomistic simulation codes that support the KIM API work seamlessly with the
 KIM-compliant interatomic models (KIM Models) distributed on this website.
 The interface is computationally efficient and often requires relatively minor
 changes to existing codes.
 .
 This package contains the development files (headers and documentation) for
 KIM-API.

Package: libkim-api2
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Shared library for KIM-API
 The KIM API is an Application Programming Interface for atomistic simulations.
 The API provides a standard for exchanging information between atomistic
 simulation codes (molecular dynamics, molecular statics, lattice dynamics,
 Monte Carlo, etc.) and interatomic models (potentials or force fields).
 It also includes a set of library routines for using the API with
 bindings for:
 .
 FORTRAN 77, Fortran 90/95, Fortran 2003
 C, C++
 .
 Atomistic simulation codes that support the KIM API work seamlessly with the
 KIM-compliant interatomic models (KIM Models) distributed on this website.
 The interface is computationally efficient and often requires relatively minor
 changes to existing codes.
 .
 This package contains the shared library for KIM-API.

Package: libkim-api-doc
Architecture: all
Depends: ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: foreign
Description: Documentation and examples for KIM-API
 The KIM API is an Application Programming Interface for atomistic simulations.
 The API provides a standard for exchanging information between atomistic
 simulation codes (molecular dynamics, molecular statics, lattice dynamics,
 Monte Carlo, etc.) and interatomic models (potentials or force fields).
 It also includes a set of library routines for using the API with
 bindings for:
 .
 FORTRAN 77, Fortran 90/95, Fortran 2003
 C, C++
 .
 Atomistic simulation codes that support the KIM API work seamlessly with the
 KIM-compliant interatomic models (KIM Models) distributed on this website.
 The interface is computationally efficient and often requires relatively minor
 changes to existing codes.
 .
 This package contains documentation and examples

=== debian/tests/control ===
Tests: cluster cluster-cpp cluster-fortran
Depends: libkim-api-dev, libkim-api-doc, openkim-models (>= 1:2021.08.11-1), build-essential, cmake, gfortran, xxd
